SystemOrganization addCategory: #'ICU-NativeBoost-Core'!

NBExternalHandle variableByteSubclass: #ICUCalendarNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUCalendarNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 11:40'!
allTimeZones

	| address enum status |
	
	address := self primOpenTimeZones: (status := ICUErrorCodeNB new).
	
	enum := ICUEnumerationNB value: address value.
	^ (self primNext: address with: status ) readString! !

!ICUCalendarNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/17/2012 09:37'!
nbLibraryNameOrHandle

	^'libicui18n.dylib'! !

!ICUCalendarNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 11:40'!
primNext: aHandle with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( char* uenum_next_48(void* aHandle, nil, ICUErrorCodeNB* anErrorCode ) )! !

!ICUCalendarNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/17/2012 09:37'!
primOpenTimeZones: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void* ucal_openTimeZones_48( ICUErrorCodeNB* anErrorCode ) )! !

NBExternalHandle variableByteSubclass: #ICUEnumerationNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/13/2012 21:53'!
close

	self primClose ! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/17/2012 09:35'!
nbLibraryNameOrHandle

	^'libicuuc.dylib'! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/17/2012 09:58'!
next

	| value status resultLength |

	value := self primNext: (status := ICUErrorCodeNB new).
	^ value! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/17/2012 09:35'!
primClose
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( char* uenum_close_48( self) )! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 11:36'!
primNext: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( char* uenum_next_48(void* self, nil, ICUErrorCodeNB* anErrorCode ) )! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/17/2012 10:05'!
primNext: aHandle with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( char* uenum_next_48(ICUEnumerationNB* aHandle, nil, ICUErrorCodeNB* anErrorCode ) )! !

Object subclass: #ICUNativeBoost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 10:27'!
getDefaultTimeZone
	"self getDefaultTimeZone"
	
	| buffer1 buffer2 length |
	
	buffer1 := ByteArray new: 200.
	buffer2 := ICUErrorCodeNB new.
	
	length := self getDefaultTimeZone: buffer1 with: buffer1 size / 2 with: buffer2. 
	
	^TwoByteString fromByteArray: buffer1 charSize: length! !

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/17/2012 09:29'!
getDefaultTimeZone: aResultBuffer with: aResultCapacity with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucal_getDefaultTimeZone_48( void* aResultBuffer, int aResultCapacity, ICUErrorCodeNB* anErrorCode ) ) module: self inModule 
	
! !

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/12/2012 17:28'!
getEnv:  aName
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ NBFFICallout cdecl: #( String  getenv( String aName) ) module: NativeBoost CLibrary
	
! !

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/12/2012 21:43'!
inModule

	^ NativeBoost forCurrentPlatform loadModule: 'libicui18n.dylib'! !

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/12/2012 21:36'!
ucModule

	^ NativeBoost forCurrentPlatform loadModule: 'libicuuc.dylib'! !

NBExternalStructure variableByteSubclass: #ICUErrorCodeNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUErrorCodeNB class methodsFor: 'fields description' stamp: 'jvds 2/12/2012 21:53'!
fieldsDesc
	^#(
		ulong status;	" # of last request processed by server "
	)! !
